/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the MessageList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageList{}

// MessageList If provided, required to provide `buttons` as well
type MessageList struct {
	// Id of text asset
	ButtonNameId string `json:"button_name_id"`
}

// NewMessageList instantiates a new MessageList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageList(buttonNameId string) *MessageList {
	this := MessageList{}
	this.ButtonNameId = buttonNameId
	return &this
}

// NewMessageListWithDefaults instantiates a new MessageList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageListWithDefaults() *MessageList {
	this := MessageList{}
	return &this
}

// GetButtonNameId returns the ButtonNameId field value
func (o *MessageList) GetButtonNameId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ButtonNameId
}

// GetButtonNameIdOk returns a tuple with the ButtonNameId field value
// and a boolean to check if the value has been set.
func (o *MessageList) GetButtonNameIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ButtonNameId, true
}

// SetButtonNameId sets field value
func (o *MessageList) SetButtonNameId(v string) {
	o.ButtonNameId = v
}

func (o MessageList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["button_name_id"] = o.ButtonNameId
	return toSerialize, nil
}

type NullableMessageList struct {
	value *MessageList
	isSet bool
}

func (v NullableMessageList) Get() *MessageList {
	return v.value
}

func (v *NullableMessageList) Set(val *MessageList) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageList) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageList(val *MessageList) *NullableMessageList {
	return &NullableMessageList{value: val, isSet: true}
}

func (v NullableMessageList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


